package es.upm.fi.dia.ontology.webode.wpbs;

import java.io.*;

public class benchmarkTimer
{
	// In the future, check if long type is needed or some smaller type is better
	/** 
	 *	Array of values of time in milliseconds
	 */
	private long[] values;
	private int index;
	
	private long start_time;
	private boolean on;
	
	public benchmarkTimer(int lenght){
		values = new long[lenght];
		index = 0;
	}
	
  public void start(){
    if (index>values.length) System.err.println("ERROR: timer full");
    if (on) System.err.println("Warning: timer was already turned on");
    on = true; 
    start_time = System.currentTimeMillis();
  }

  public void stop(){
    if (index>values.length) System.err.println("ERROR: timer full");
    if (!on) System.err.println("Warning: timer wasn't turned on");
    on = false;  
    values[index] = (System.currentTimeMillis()-start_time);
    index++;
  }
  
  public void print(){
  	for (int i=0; i<values.length; i++){
  		System.out.print(values[i]+" ");
  	}
  	System.out.println();
  }

  public void save(String file_name) throws IOException {
  	File file = new File(file_name);
  	
 		FileWriter out = new FileWriter(file);		  	
  	out.write(values.length+System.getProperty("line.separator"));
 		for (int i=0; i<values.length; i++){
  		out.write(Long.toString(values[i])+System.getProperty("line.separator"));
		}

 		out.close();
  }
}